<?php
defined('_JEXEC') or die('Restricted access');

class plgJshoppingProductsProduct_attr_1images extends JPlugin {
	
	public function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		
    }
    
    public function onBeforeBuildSelectAttribute(&$attributeValues, &$attributeActive, &$selects, &$attrib, &$obj){
		$db = JFactory::getDbo();
		$query = "SELECT * FROM `#__jshopping_products_attr` WHERE product_id=".(int)$obj->product_id." AND ext_attribute_product_id>0";
        $db->setQuery($query);
		$list = $db->loadObjectList();
		$attrsid = array_keys($attributeValues);
		$data = [];
		foreach($list as $k => $v) {
			foreach($attrsid as $aid) {
				if ($v->{'attr_'.$aid} != 0 && !isset($data[$aid][$v->{'attr_'.$aid}])) {
					$img = $this->getImage($v->ext_attribute_product_id);
					if ($img) {
						$data[$aid][$v->{'attr_'.$aid}] = $img;
					}
				}
			}
		}
		
		foreach($attributeValues as $aid => $listval) {
			foreach($listval as $k => $v) {
				if (isset($data[$aid][$v->val_id])) {
					$attributeValues[$aid][$k]->prod_img = $data[$aid][$v->val_id];
				}
			}
		}
    }
	
	private function getImage($pid) {		
		$db = JFactory::getDbo();
		$query = "SELECT image FROM `#__jshopping_products` WHERE product_id=".(int)$pid;
        $db->setQuery($query);
		return $db->loadResult();
	}
	
	public function onBuildSelectAttribute(&$attributeValues, &$attributeActive, &$selects, &$options, &$attr_id, &$v) {
		$jshopConfig = JSFactory::getConfig();
		$options = $attributeValues[$attr_id];		
		
		if ($v->attr_type == 2) {
			foreach($options as $k2=>$v2) {
				if ($v2->prod_img) {
					$options[$k2]->value_name = "<img src='".$jshopConfig->image_product_live_path."/thumb_".$v2->prod_img."' alt='' /> <span>".trim(strip_tags($v2->value_name))."</span>";
				} elseif ($v2->image) {
					$options[$k2]->value_name = "<img src='".$jshopConfig->image_attributes_live_path."/".$v2->image."' alt='' /> <span>".trim(strip_tags($v2->value_name))."</span>";
				}
			}

			if ($jshopConfig->attr_display_addprice) {
				foreach($options as $k2=>$v2) {
					if (($v2->price_mod=="+" || $v2->price_mod=="-" || $jshopConfig->attr_display_addprice_all_sign) && $v2->addprice>0){
						$ext_price_info = " (".$v2->price_mod.formatprice($v2->addprice).")";
						$options[$k2]->value_name .=$ext_price_info;
					}
				}
			}

			$radioseparator = '';
			if ($jshopConfig->radio_attr_value_vertical) $radioseparator = "<br/>";
			foreach($options as $k2=>$v2){
				$options[$k2]->value_name = "<span class='radio_attr_label'>".$v2->value_name."</span>";
			}

			$selects[$attr_id]->selects = sprintRadioList($options, 'jshop_attr_id['.$attr_id.']', 'onclick="setAttrValue(\''.$attr_id.'\', this.value);"', 'val_id', 'value_name', isset($attributeActive[$attr_id]) ? $attributeActive[$attr_id] : 0, $radioseparator);
			$selects[$attr_id]->selects = str_replace(array("\n","\r","\t"), "", $selects[$attr_id]->selects);
		}
		
	}
    
}